/*
** Module   : CookieCollection.java
** Abstract : Implementation of the builtin class.
**
** Copyright (c) 2020-2022, Golden Code Development Corporation.
**
** -#- -I- --Date-- -------------------------------Description--------------------------------
** 001 MP  20200603 First version, stubs taken by converting the skeleton using FWD.
** 002 ME  20210128 Implement remaining methods as of OE12.2.
** 003 CA  20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy
**                  signature.
**     CA  20220923 Variable definitions (including associated with parameters) must be done always outside of 
**                  the BlockManager API
*/

/*
** This program is free software: you can redistribute it and/or modify
** it under the terms of the GNU Affero General Public License as
** published by the Free Software Foundation, either version 3 of the
** License, or (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU Affero General Public License for more details.
**
** You may find a copy of the GNU Affero GPL version 3 at the following
** location: https://www.gnu.org/licenses/agpl-3.0.en.html
** 
** Additional terms under GNU Affero GPL version 3 section 7:
** 
**   Under Section 7 of the GNU Affero GPL version 3, the following additional
**   terms apply to the works covered under the License.  These additional terms
**   are non-permissive additional terms allowed under Section 7 of the GNU
**   Affero GPL version 3 and may not be removed by you.
** 
**   0. Attribution Requirement.
** 
**     You must preserve all legal notices or author attributions in the covered
**     work or Appropriate Legal Notices displayed by works containing the covered
**     work.  You may not remove from the covered work any author or developer
**     credit already included within the covered work.
** 
**   1. No License To Use Trademarks.
** 
**     This license does not grant any license or rights to use the trademarks
**     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
**     of Golden Code Development Corporation. You are not authorized to use the
**     name Golden Code, FWD, or the names of any author or contributor, for
**     publicity purposes without written authorization.
** 
**   2. No Misrepresentation of Affiliation.
** 
**     You may not represent yourself as Golden Code Development Corporation or FWD.
** 
**     You may not represent yourself for publicity purposes as associated with
**     Golden Code Development Corporation, FWD, or any author or contributor to
**     the covered work, without written authorization.
** 
**   3. No Misrepresentation of Source or Origin.
** 
**     You may not represent the covered work as solely your work.  All modified
**     versions of the covered work must be marked in a reasonable way to make it
**     clear that the modified work is not originating from Golden Code Development
**     Corporation or FWD.  All modified versions must contain the notices of
**     attribution required in this license.
*/

package com.goldencode.p2j.oo.net.http;

import com.goldencode.p2j.util.*;
import com.goldencode.p2j.util.BlockManager.Action;
import com.goldencode.p2j.util.BlockManager.Condition;

import static com.goldencode.p2j.report.ReportConstants.*;
import static com.goldencode.p2j.util.BlockManager.*;
import static com.goldencode.p2j.util.InternalEntry.Type;

import com.goldencode.p2j.oo.lang._BaseObject_;

/**
 * Business logic (converted to Java from the 4GL source code
 * in OpenEdge/Net/HTTP/CookieCollection.cls).
 */
@LegacyResource(resource = "OpenEdge.Net.HTTP.CookieCollection")
@LegacyResourceSupport(supportLvl = CVT_LVL_FULL|RT_LVL_FULL)
public class CookieCollection
extends com.goldencode.p2j.oo.core.collections.LegacyCollection
{
   public void __net_http_CookieCollection_execute__()
   {
      externalProcedure(CookieCollection.class, CookieCollection.this, new Block((Body) () -> 
      {
         onBlockLevel(Condition.ERROR, Action.THROW);
         {
         }
      }));
   }

   @LegacySignature(type = Type.CONSTRUCTOR)
   @LegacyResourceSupport(supportLvl = CVT_LVL_FULL|RT_LVL_FULL)
   public void __net_http_CookieCollection_constructor__()
   {
      internalProcedure(CookieCollection.class, this, "__net_http_CookieCollection_constructor__", new Block((Body) () -> 
      {
         __core_collections_LegacyCollection_constructor__();
      }));
   }

   @LegacySignature(type = Type.CONSTRUCTOR, parameters = 
   {
      @LegacyParameter(name = "poCollection", type = "OBJECT", qualified = "openedge.core.collections.icollection", mode = "INPUT")
   })
   @LegacyResourceSupport(supportLvl = CVT_LVL_FULL|RT_LVL_FULL)
   public void __net_http_CookieCollection_constructor__(final object<? extends com.goldencode.p2j.oo.core.collections.Icollection> poCollection)
   {
      internalProcedure(CookieCollection.class, this, "__net_http_CookieCollection_constructor__", new Block((Body) () -> 
      {
         __core_collections_LegacyCollection_constructor__(poCollection);
      }));
   }

   @LegacySignature(returns = "LOGICAL", type = Type.METHOD, name = "Add", parameters = 
   {
      @LegacyParameter(name = "newObject", type = "OBJECT", qualified = "openedge.net.http.cookie", mode = "INPUT")
   })
   @LegacyResourceSupport(supportLvl = CVT_LVL_FULL|RT_LVL_FULL)
   public logical add_1(final object<? extends com.goldencode.p2j.oo.net.http.Cookie> newObject)
   {
      return function(CookieCollection.class, this, "Add", logical.class, new Block((Body) () -> 
      {
         returnNormal(super.add(newObject));
      }));
   }

   @LegacySignature(returns = "LOGICAL", type = Type.METHOD, name = "AddArray", parameters = 
   {
      @LegacyParameter(name = "poArray", type = "OBJECT", extent = -1, qualified = "openedge.net.http.cookie", mode = "INPUT")
   })
   @LegacyResourceSupport(supportLvl = CVT_LVL_FULL|RT_LVL_FULL)
   public logical addArray_1(final object<? extends com.goldencode.p2j.oo.net.http.Cookie>[] poArray)
   {
      return function(CookieCollection.class, this, "AddArray", logical.class, new Block((Body) () -> 
      {
         returnNormal(super.addArray(poArray));
      }));
   }

   @LegacySignature(returns = "LOGICAL", type = Type.METHOD, name = "Remove", parameters = 
   {
      @LegacyParameter(name = "oldObject", type = "OBJECT", qualified = "openedge.net.http.cookie", mode = "INPUT")
   })
   @LegacyResourceSupport(supportLvl = CVT_LVL_FULL|RT_LVL_FULL)
   public logical remove_1(final object<? extends com.goldencode.p2j.oo.net.http.Cookie> oldObject)
   {
      return function(CookieCollection.class, this, "Remove", logical.class, new Block((Body) () -> 
      {
         returnNormal(super.remove(oldObject));
      }));
   }

   @LegacySignature(returns = "LOGICAL", type = Type.METHOD, name = "Contains", parameters = 
   {
      @LegacyParameter(name = "checkObject", type = "OBJECT", qualified = "openedge.net.http.cookie", mode = "INPUT")
   })
   @LegacyResourceSupport(supportLvl = CVT_LVL_FULL|RT_LVL_FULL)
   public logical contains_1(final object<? extends com.goldencode.p2j.oo.net.http.Cookie> checkObject)
   {
      return function(CookieCollection.class, this, "Contains", logical.class, new Block((Body) () -> 
      {
         returnNormal(super.contains(checkObject));
      }));
   }

   @LegacySignature(returns = "OBJECT", type = Type.METHOD, name = "ToCookieArray", extent = -1, qualified = "openedge.net.http.cookie")
   @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | RT_LVL_FULL)
   public object<? extends com.goldencode.p2j.oo.net.http.Cookie>[] toCookieArray()
   {
      object[][] cookies = { TypeFactory.objectExtent(Cookie.class) };
      
      return extentFunction(CookieCollection.class, this, "ToCookieArray", object.class,
               new Block((Body) () -> {
                  object<? extends _BaseObject_>[] arr = super.toArray();
                  cookies[0] = ArrayAssigner.resize(cookies[0], arr.length);
                  for (int i = 0; i < cookies.length; i++)
                  {
                     cookies[0][i].assign(ObjectOps.cast(arr[i], Cookie.class));
                  }
                  
                  returnExtentNormal(cookies[0]);
               }));
   }
}
